apiVersion: {{ sts_apivers }}
kind: StatefulSet
metadata:
  labels:
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ trivy_name }}
  name: {{ trivy_name }}
  namespace: {{ namespace }}
spec:
  podManagementPolicy: Parallel
  replicas: {{ trivy_replicas }}
  selector:
    matchLabels:
      name: {{ trivy_name }}
  serviceName: {{ trivy_name }}
  template:
    metadata:
      labels:
        name: {{ trivy_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ trivy_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ trivy_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - args:
        - server
{% if trivy_cache == 'redis' %}
        - --cache-backend
        - redis://{{ cache_name }}-proxy.{{ namespace }}.svc.{{ cluster_domain }}:6379
{% endif %}
        - --listen
        - 0.0.0.0:8080
        env:
{% if proxy_host | default(False) %}
        - name: http_proxy
          value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
        - name: https_proxy
          value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
        - name: no_proxy
          value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ namespace }}.svc.{{ cluster_domain }},.{{ namespace }}.svc,.{{ namespace }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
        - name: HTTP_PROXY
          value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
        - name: HTTPS_PROXY
          value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
        - name: NO_PROXY
          value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ namespace }}.svc.{{ cluster_domain }},.{{ namespace }}.svc,.{{ namespace }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
{% elif squid_address is defined %}
        - name: http_proxy
          value: {{ squid_address }}
        - name: https_proxy
          value: {{ squid_address }}
        - name: no_proxy
          value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ namespace }}.svc.{{ cluster_domain }},.{{ namespace }}.svc,.{{ namespace }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
        - name: HTTP_PROXY
          value: {{ squid_address }}
        - name: HTTPS_PROXY
          value: {{ squid_address }}
        - name: NO_PROXY
          value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ namespace }}.svc.{{ cluster_domain }},.{{ namespace }}.svc,.{{ namespace }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
{% else %}
        - name: http_proxy
          value: ""
        - name: https_proxy
          value: ""
        - name: no_proxy
          value: ""
        - name: HTTP_PROXY
          value: ""
        - name: HTTPS_PROXY
          value: ""
        - name: NO_PROXY
          value: ""
{% endif %}
        - name: TRIVY_DEBUG
          value: "{% if do_debugs %}true{% endif %}"
        - name: TRIVY_CACHE_DIR
          value: /data
        - name: TRIVY_INSECURE
          value: "true"
        - name: TZ
          value: {{ timezone }}
        image: {{ (opsimages | json_query("[?name=='trivy'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 38
{% else %}
          failureThreshold: 5
{% endif %}
          initialDelaySeconds: 30
          periodSeconds: 30
          tcpSocket:
            port: 8080
        name: trivy
        ports:
        - containerPort: 8080
        readinessProbe:
          httpGet:
            path: /healthz
            port: 8080
        resources:
          limits:
            cpu: "{{ trivy_cpu_limit }}"
            memory: "{{ trivy_memory_limit }}"
          requests:
            cpu: "{{ trivy_cpu_request }}"
            memory: "{{ trivy_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 39
          initialDelaySeconds: 30
          periodSeconds: 30
          tcpSocket:
            port: 8080
{% endif %}
        volumeMounts:
        - mountPath: /data
          name: data
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-infra
{% endif %}
{% if k8s_flavor == 'kubernetes' %}
      securityContext:
        runAsUser: {{ k8s_unprivileged_userid }}
{% else %}
      securityContext: {}
{% endif %}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ trivy_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
  updateStrategy:
    type: RollingUpdate
  volumeClaimTemplates:
  - metadata:
      name: data
    spec:
      accessModes: [ ReadWriteOnce ]
      resources:
        requests:
{% if trivy_cache == 'redis' %}
          storage: 2Gi
{% else %}
          storage: "{{ trivy_data_capacity }}"
{% endif %}
{% if rwo_storage is defined %}
      storageClassName: {{ rwo_storage }}
{% endif %}
